(define-derived-mode buggy-mode nil "buggy"
  (setf max-redisplay-ticks 100)
  (setf font-lock-defaults '(nil nil t nil (font-lock-fontify-region-function . buggy-fontifier)))
  (font-lock-mode 1))

(defvar times 0)

(defun buggy-fontifier (start end loudly)
  (message "Called %d times" (setq times (1+ times)))
  (add-face-text-property start (min (+ start 15) end) 'bold)
  (while t
    "whoopsie"
    (redisplay t))
  nil)

(switch-to-buffer "*scratch*")
(dotimes (k 50)
  (insert "Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.\n\n"))
(goto-char 1)
(buggy-mode)
